/* 
* Copyright 1998-2014 VIA Technologies, Inc. All Rights Reserved.
* Copyright 2001-2014 S3 Graphics, Inc. All Rights Reserved.
* Copyright 2013-2014 Shanghai Zhaoxin Semiconductor Co., Ltd. All Rights Reserved.
*
* This file is part of zx.ko
* 
* zx.ko is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* zx.ko is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <linux/module.h>
#include "kernel_interface.h"

EXPORT_SYMBOL(krnl_init_adapter);
EXPORT_SYMBOL(krnl_deinit_adapter);
EXPORT_SYMBOL(krnl_dump_cbios_info);
EXPORT_SYMBOL(krnl_mem_read);
EXPORT_SYMBOL(krnl_mem_write);
EXPORT_SYMBOL(krnl_mmio_read);
EXPORT_SYMBOL(krnl_mmio_write);
EXPORT_SYMBOL(krnl_dump_resource);
EXPORT_SYMBOL(krnl_debugfs_dump);
EXPORT_SYMBOL(krnl_notify_vesa_mode);

EXPORT_SYMBOL(krnl_save_force_dvfs_index);
EXPORT_SYMBOL(krnl_dump_sensor_temprature);
EXPORT_SYMBOL(krnl_force_dvfs_index);
EXPORT_SYMBOL(krnl_force_dvfs_video_index);
/*
** For resource final clean up
** Especially for application exit abnormally
** This function will be responsible for recall
** all the resources.
*/
EXPORT_SYMBOL(krnl_final_cleanup);

/*
** 2D client related kernel interface
*/
EXPORT_SYMBOL(krnl_create_2ddevice);
EXPORT_SYMBOL(krnl_destroy_2ddevice);

EXPORT_SYMBOL(krnl_wait_chip_idle);

EXPORT_SYMBOL(krnl_kickoff_2d_draw);

EXPORT_SYMBOL(krnl_get_iga_info);

EXPORT_SYMBOL(krnl_get_iga_allocation);

EXPORT_SYMBOL(krnl_notify_resize_fb);

EXPORT_SYMBOL(krnl_enum_sub_device);

EXPORT_SYMBOL(krnl_wait_allocation_idle);

EXPORT_SYMBOL(krnl_enter_zx_graphics_mode);

EXPORT_SYMBOL(krnl_leave_zx_graphics_mode);

EXPORT_SYMBOL(krnl_get_allocation_state);

/*
** Display manager kernel interface
*/
EXPORT_SYMBOL(krnl_query_display_caps);
EXPORT_SYMBOL(krnl_query_output_caps);

EXPORT_SYMBOL(krnl_get_device_comb);

EXPORT_SYMBOL(krnl_set_mode);
EXPORT_SYMBOL(krnl_register_mhl_callback);
EXPORT_SYMBOL(krnl_get_hdmi_audio_format);
EXPORT_SYMBOL(krnl_set_ps);
EXPORT_SYMBOL(krnl_set_cursor);
EXPORT_SYMBOL(krnl_set_gamma);
EXPORT_SYMBOL(krnl_set_dpms);
EXPORT_SYMBOL(krnl_get_dev_monitor_type);
EXPORT_SYMBOL(krnl_get_hpd_info);

EXPORT_SYMBOL(krnl_get_mode_timing);
EXPORT_SYMBOL(krnl_check_device_combination);
EXPORT_SYMBOL(krnl_get_iga_mask_per_allocation);
EXPORT_SYMBOL(krnl_get_iga_vsync_interval);
EXPORT_SYMBOL(krnl_set_interactive);
EXPORT_SYMBOL(krnl_send_dsi_cmd);
EXPORT_SYMBOL(krnl_mhl_cbus_send_command);

/*
**  power management kernel interface
*/
EXPORT_SYMBOL(krnl_save_state);
EXPORT_SYMBOL(krnl_restore_state);

EXPORT_SYMBOL(krnl_pwm_func_ctrl);
EXPORT_SYMBOL(krnl_brightness_set);
EXPORT_SYMBOL(krnl_brightness_get);
EXPORT_SYMBOL(krnl_query_brightness_caps);
EXPORT_SYMBOL(krnl_get_map_allocation_info);
EXPORT_SYMBOL(krnl_cabc_set);
EXPORT_SYMBOL(krnl_get_dbg_level);
EXPORT_SYMBOL(krnl_set_dbg_level);


/*
** interrupt related interface
*/
EXPORT_SYMBOL(krnl_get_isr_func);
EXPORT_SYMBOL(krnl_enable_msi);
EXPORT_SYMBOL(krnl_disable_interrupt);
EXPORT_SYMBOL(krnl_enable_interrupt);
EXPORT_SYMBOL(krnl_wait_event);

EXPORT_SYMBOL(krnl_create_stream);
EXPORT_SYMBOL(krnl_destroy_stream);
EXPORT_SYMBOL(krnl_display_frame);

EXPORT_SYMBOL(krnl_cec_ctl);

EXPORT_SYMBOL(krnl_get_video_hardware_capability);
EXPORT_SYMBOL(krnl_get_address_config);
EXPORT_SYMBOL(krnl_query_info);

EXPORT_SYMBOL(krnl_flip);
EXPORT_SYMBOL(krnl_present);

EXPORT_SYMBOL(krnl_escape_call);
#if defined(__x86_64__)
EXPORT_SYMBOL(krnl_escape_call_compat);
#endif

/*
 * SDK interface
 */
EXPORT_SYMBOL(krnl_create_device);
EXPORT_SYMBOL(krnl_destroy_device);
EXPORT_SYMBOL(krnl_create_allocation);
EXPORT_SYMBOL(krnl_destroy_allocation);
EXPORT_SYMBOL(krnl_lock_allocation);
EXPORT_SYMBOL(krnl_unlock_allocation);
EXPORT_SYMBOL(krnl_flush_allocation);
EXPORT_SYMBOL(krnl_open_allocation);
EXPORT_SYMBOL(krnl_acquire_aperture);
EXPORT_SYMBOL(krnl_release_aperture);

EXPORT_SYMBOL(krnl_copyarea);
EXPORT_SYMBOL(krnl_fillrect);
EXPORT_SYMBOL(krnl_imageblit);
EXPORT_SYMBOL(krnl_accel_flip);

/*
** misc things
*/
EXPORT_SYMBOL(krnl_set_callback_func);

/*
** perf event manager
*/
EXPORT_SYMBOL(krnl_begin_perf_event);
EXPORT_SYMBOL(krnl_end_perf_event);
EXPORT_SYMBOL(krnl_get_perf_event);
EXPORT_SYMBOL(krnl_send_perf_event);
EXPORT_SYMBOL(krnl_get_perf_status);
EXPORT_SYMBOL(krnl_begin_miu_dump_perf_event);
EXPORT_SYMBOL(krnl_end_miu_dump_perf_event);
EXPORT_SYMBOL(krnl_set_miu_reg_list_perf_event);
EXPORT_SYMBOL(krnl_get_miu_dump_perf_event);
EXPORT_SYMBOL(krnl_direct_get_miu_dump_perf_event);

/*
** context
*/
EXPORT_SYMBOL(krnl_create_context);
EXPORT_SYMBOL(krnl_destroy_context);
EXPORT_SYMBOL(krnl_wait_context_idle);

/*
** render
*/
EXPORT_SYMBOL(krnl_render);

/*
** deinterlace 
*/
EXPORT_SYMBOL(krnl_create_di_context);
EXPORT_SYMBOL(krnl_destroy_di_context);


EXPORT_SYMBOL(krnl_hdcp_op);


/*
** fence sync object
*/
EXPORT_SYMBOL(krnl_create_fence_sync_object);
EXPORT_SYMBOL(krnl_destroy_fence_sync_object);
EXPORT_SYMBOL(krnl_wait_fence_sync_object);
EXPORT_SYMBOL(krnl_fence_value);
EXPORT_SYMBOL(krnl_is_fence_object_signaled);


EXPORT_SYMBOL(krnl_flip_limit);

EXPORT_SYMBOL(krnl_set_power_perf_mode);
EXPORT_SYMBOL(krnl_begin_end_isp_dvfs);

EXPORT_SYMBOL(krnl_reference_allocation);
EXPORT_SYMBOL(krnl_unreference_allocation);

EXPORT_SYMBOL(krnl_allocation_inc_refcount);
EXPORT_SYMBOL(krnl_destroy_allocation_export);
EXPORT_SYMBOL(krnl_graphics_client_create);

EXPORT_SYMBOL(krnl_power_off_crtc);

EXPORT_SYMBOL(krnl_free_vesafb_tempbuffer);

EXPORT_SYMBOL(krnl_set_fb_shadow_for_adapter);

EXPORT_SYMBOL(krnl_get_bo_file);
EXPORT_SYMBOL(krnl_set_bo_file);

EXPORT_SYMBOL(krnl_access_aux);

/**************** module ******************/

static int __init zx_core_init(void)
{
    return 0;
}

static void __exit zx_core_exit(void)
{
}

module_init(zx_core_init);
module_exit(zx_core_exit);
MODULE_LICENSE("Zhaoxin");

int zx_pwm_mode = -1;
int zx_dvfs_mode = -1;
int zx_worker_thread_enable = 1;
int zx_recovery_enable = 1;
int zx_hang_dump = 0;//0-disable, 1-pre hang, 2-post hang, 3-duplicate hang
int zx_force_3dblt = 0;
EXPORT_SYMBOL(zx_hang_dump);
int zx_run_on_qt = 0;
EXPORT_SYMBOL(zx_run_on_qt);
int zx_flag_buffer_verify = 0;//0 - disable, 1 - enable
int zx_debug_secure = 0;//0-disable 1-secure rang off  2-force video secure 3-force camera video
int zx_one_shot_enable = -1;
int zx_freezable_patch = 0;
int zx_hotplug_polling_enable = 0;
int zx_reboot_patch = 0;
int zx_vesa_tempbuffer_enable = 0;

module_param(zx_vesa_tempbuffer_enable, int, 0444);
module_param(zx_pwm_mode, int, 0444);
module_param(zx_dvfs_mode, int, 0444);
module_param(zx_worker_thread_enable, int, 0444);
module_param(zx_recovery_enable, int, 0444);
module_param(zx_hang_dump, int, 0444);
module_param(zx_flag_buffer_verify, int, 0444);
module_param(zx_debug_secure, int, 0444);
module_param(zx_one_shot_enable, int, 0444);
module_param(zx_run_on_qt, int, 0444);
module_param(zx_reboot_patch, int, 0444);
EXPORT_SYMBOL(zx_reboot_patch);
module_param(zx_hotplug_polling_enable, int, 0444);
module_param(zx_freezable_patch, int, 0444);
module_param(zx_force_3dblt, int, 0444);
EXPORT_SYMBOL(zx_freezable_patch);

MODULE_PARM_DESC(zx_pwm_mode, "control pwm of zx");
MODULE_PARM_DESC(zx_dvfs_mode, "control dvfs of zx");
MODULE_PARM_DESC(zx_worker_thread_enable, "control worker thread on/off");
MODULE_PARM_DESC(zx_recovery_enable, "enable recovery when hw hang");
MODULE_PARM_DESC(zx_hang_dump, "enable hang dump");
MODULE_PARM_DESC(zx_flag_buffer_verify, "verify the flag buffer whether be invalid overwrite");
MODULE_PARM_DESC(zx_debug_secure, "debug secure range");
MODULE_PARM_DESC(zx_one_shot_enable, "control one shot on/off");
MODULE_PARM_DESC(zx_run_on_qt, "control wether run on QT");
MODULE_PARM_DESC(zx_hotplug_polling_enable, "control wether enable hotplug polling");
MODULE_PARM_DESC(zx_freezable_patch, "control wether enable freezable patch");
MODULE_PARM_DESC(zx_reboot_patch, "control wether enable reboot patch");
MODULE_PARM_DESC(zx_vesa_tempbuffer_enable, "control wether reserve memory during boot");
