/* 
* Copyright 1998-2014 VIA Technologies, Inc. All Rights Reserved.
* Copyright 2001-2014 S3 Graphics, Inc. All Rights Reserved.
* Copyright 2013-2014 Shanghai Zhaoxin Semiconductor Co., Ltd. All Rights Reserved.
*
* This file is part of zx.ko
* 
* zx.ko is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* zx.ko is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __ZX_IOCTL_COMPAT_H__
#define __ZX_IOCTL_COMPAT_H__ 

#include"zx.h"
#include"zx_def.h"
#include"zx_driver.h"

extern int zx_ioctl_get_busid(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_display_info(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_iga_info(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_addctx(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_rmctx(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_lock_ctx(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_unlock_ctx(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_clip_notify_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_add_drawable_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_remove_drawable(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_drawsize(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_query_display_caps(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_query_output_caps_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_set_mode(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_cursor(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_gamma_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_dpms(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_mode_timing(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_2d_init(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_init_screen_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_deinit_screen_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_chip_idle(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_escape_call_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_2d_draw_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_acquire_aperture(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_release_aperture(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_leave_vt(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_enter_vt(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_check_device_combination(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_set_ps(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_enum_sub_device(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_allocation(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_open_allocation(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_allocation(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_lock_allocation_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_unlock_allocation(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_flush_allocation(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_allocation_idle(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_video_get_hw_caps(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_get_address_config_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_query_info(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_func(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_flip(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_cec_ctl(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_present(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_drawable_surface(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_vsync_info(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_device(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_device(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_begin_perf_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_end_perf_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_get_perf_event_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_send_perf_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_perf_status(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_begin_miu_dump_perf_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_end_miu_dump_perf_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_set_miu_reg_list_perf_event_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_get_miu_dump_perf_event_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_direct_get_miu_dump_perf_event_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_create_context_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_context(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_context_idle(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_render_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_query_chip_id(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_hdcp_op(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_fence_sync_object(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_fence_sync_object(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_fence_sync_object(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_fence_value(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_fence_fd(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_flip_limit(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_ipc_operation_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_stream(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_stream(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_display_frame(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_set_interactive(zx_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int zx_ioctl_send_dsi_cmd_compat(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_mhl_cbus_send_command(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_create_di_context(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_destroy_di_context(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_register_mhl_callback(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_set_power_perf_mode(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_device_comb(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_gfx_stm(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_hdmi_audio_format(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_hpd_info(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_handle_to_fd(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_fd_to_handle(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_ust_msc(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_get_allocation_state(zx_file_t* priv, unsigned int cmd, unsigned long arg);
extern int zx_ioctl_wait_event(zx_file_t* priv, unsigned int cmd, unsigned long arg);

typedef struct zx_clipnotify_compat
{
    int x;
    int y;
    int width;
    int height;

    short screen_x;
    short screen_y;

    int numClipRects;
    int xId;
    unsigned int kdrawId;
    int scrnIndex;
    int iga_mask;
    unsigned int hAllocation;

    compat_uptr_t clipRects;
    /* How many clipRects knl malloc */
    int clipRectsVol;
}zx_clipnotify_compat_t;

typedef struct zx_drawable_compat
{
    int server_index;
    unsigned int xId;
    zx_clipnotify_compat_t clipNotify[MAX_SCREENS];
    int refCount;
}zx_drawable_compat_t;

typedef struct
{
    int  type;            /* in */
    int  monitor_type;    /* out */
    int  monitor_width;   /* out */
    int  monitor_height;  /* out */
    int  connected;       /* output */

    int  edid_size;       /* output */
    compat_uptr_t edid;           /* output */

    int  mode_num;        /* output */
    compat_uptr_t modes;    /* output */

    int  _3dmode_num;     /* output */
    compat_uptr_t _3dmodes;       /* output */

    int  support_audio;   /* output */
}zx_output_caps_compat_t;

typedef struct
{
    int crtc;
    compat_uptr_t  pLutBuf;
}zx_gamma_info_compat_t;

typedef struct
{
    int server_index;
    int scrnIndex;
    int master;
    int samm;
    int mamm;
    int x;
    int y;
    int width;
    int height;
    int bpp;
    int pitch;
    unsigned int device;
    unsigned int hwFormat;
    int          rotate;
    int          gbd;
    int          use_rxa;
    int          bDuoView;
    compat_ulong_t fbOffset;
    unsigned int hAllocation;
}zx_2d_screen_compat_t;

typedef struct
{
    unsigned int   len;  /* in */
    unsigned int   hSrcAllocation;   /* in */
    unsigned int   hDstAllocation;   /* in */
    unsigned int   hMaskAllocation;  /* in */
    unsigned int   kernel_mode_command;
    compat_uptr_t  cmd;  /* in */
}zx_2d_draw_compat_t;

typedef struct
{
    unsigned int device;            /* in */
    unsigned int allocation;        /* in */
    unsigned int acquire_apeture :1;/* in */
    unsigned int read_only       :1;/* in */
    unsigned int write_only      :1;/* in */
    unsigned int cache_type      :3;/* in */

    compat_uptr_t virt_addr;        /* out */
}zx_lock_allocation_compat_t;

typedef struct zx_get_perf_event_tag_compat
{
    unsigned int max_event_num;             /* in */
    unsigned int max_event_buffer_size;     /* in */
    compat_uptr_t event_buffer;             /* in/out */
    unsigned int event_filled_num;          /* out */
    unsigned int event_buffer_filled_size;  /* out */
    unsigned int event_lost_num;            /* out */
    unsigned long long event_lost_timestamp;/* out */

    compat_uptr_t isr_event_buffer;         /* in/out */
    unsigned int isr_filled_num;            /* out */
    unsigned int isr_filled_size;           /* out */
} zx_get_perf_event_compat_t;

typedef struct zx_miu_reg_list_tag_compat
{
    unsigned int          miu_table_length;
    compat_uptr_t         miu_table;
}zx_miu_reg_list_perf_event_compat_t;

typedef struct zx_get_miu_dump_tag_compat
{
    unsigned int max_event_num;
    unsigned int max_event_buffer_size;
    compat_uptr_t event_buffer;
    unsigned int event_filled_num;
    unsigned int event_buffer_filled_size;
    unsigned int event_lost_num;
    unsigned long long event_lost_timestamp;
}zx_get_miu_dump_perf_event_compat_t;

typedef struct zx_direct_get_miu_dump_tag_compat
{
    compat_uptr_t miu_table;
    unsigned int        miu_table_length;
    unsigned int        timestamp_high;
    unsigned int        timestamp_low;
}zx_direct_get_miu_dump_perf_event_compat_t;

typedef struct
{
    unsigned int  device;                   /* in   */
    unsigned int  engine_index;             /* in   */
    unsigned int  flags;                    /* in   */
    unsigned int  context;                  /* out  */
    compat_uptr_t command_buffer;           /* out  */
    unsigned int  command_buffer_size;      /* out  */
    compat_uptr_t allocation_list;          /* out  */
    unsigned int  allocation_list_size;     /* out  */
    compat_uptr_t patch_location_list;      /* out  */
    unsigned int  patch_location_list_size; /* out  */
    compat_uptr_t sync_object_list;         /* out  */
    unsigned int  sync_object_list_size;    /* out  */
}zx_create_context_compat_t;

typedef struct
{
    unsigned int            context;                        /* in                   */
    unsigned int            command_length;                 /* in(number of bytes)  */
    unsigned int            command_offset;                 /* in                   */
    unsigned int            allocation_count;               /* in                   */
    unsigned int            patch_location_count;           /* in                   */
    unsigned int            sync_object_count;              /* in                   */
    compat_uptr_t           new_command_buffer;             /* out                  */
    unsigned int            new_command_buffer_size;        /* in/out               */
    compat_uptr_t           new_allocation_list;            /* out                  */
    unsigned int            new_allocation_list_size;       /* in/out               */
    compat_uptr_t           new_patch_location_list;        /* out                  */
    unsigned int            new_patch_location_list_size;   /* in/out               */
    unsigned int            flags;                          /* in                   */
}zx_render_compat_t;

typedef struct
{
    unsigned int      dsi_index;
    unsigned int      virtual_ch;
    unsigned int      content_type;          /* 0: DCS cmd, 1:generic cmd */
    unsigned char     data_len;
    compat_uptr_t     data_buf;
    unsigned char     received_payload[16];
    unsigned char     payload_len;
    unsigned int      is_HSmode_only;        /* 0: both LP and HS mode, 1: only can be transferred in HS mode */
}zx_dsi_read_cmd_compat_t;

typedef struct
{
    unsigned int      dsi_index;
    unsigned int      virtual_ch;
    unsigned int      packet_type;           /* 0: short packet, 1: long packet */
    unsigned int      content_type;          /* 0: DCS cmd, 1:generic cmd */
    unsigned short    data_len;
    compat_uptr_t     data_buf;
    unsigned int      is_need_ack;           /* 0: no need ack, 1: need ack */
    unsigned int      is_HSmode_only;        /* 0: both LP and HS mode, 1: only can be transferred in HS mode */
}zx_dsi_write_cmd_compat_t;

typedef struct
{
    zx_dsi_opcode    dsi_opcode;
    
    union
    {
        zx_dsi_read_cmd_compat_t     read_cmd;
        zx_dsi_write_cmd_compat_t    write_cmd;
    };
}zx_dsi_cmd_compat_t;

typedef struct
{
    enum zx_ipc_type           type;
    enum zx_operation_type     operation;
    unsigned int                timeout;
    unsigned int                size_in;
    unsigned int                size_out;
    compat_uptr_t               send_data;
    compat_uptr_t               reply_data;
}zx_ipc_operation_compat_t;

#endif
